/**
 * Copyright (c) 2020 Raspberry Pi (Trading) Ltd.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include <stdio.h>
#include "pico/stdlib.h"
#include "hardware/gpio.h"
#include "hardware/adc.h"
#include "xiao_rp2040.h"

const uint PIN_THERMISTOR = A0;
const uint PIN_LED_HEATER = D1;

const uint PIN_LED_EYES = D8;

const uint PIN_BUZZER = D10;

const uint PIN_BUTTON_DEC = D3;
const uint PIN_BUTTON_INC = D7;

int main() {
  stdio_init_all();

  adc_init();

  adc_gpio_init(PIN_THERMISTOR);

  adc_select_input(0);


  gpio_init(PIN_LED_HEATER);
  gpio_set_dir(PIN_LED_HEATER, GPIO_OUT);

  gpio_init(PIN_BUTTON_DEC);
  gpio_set_dir(PIN_BUTTON_DEC, GPIO_IN);
  gpio_pull_down(PIN_BUTTON_DEC);
  gpio_set_input_enabled(PIN_BUTTON_DEC, 1);

  gpio_init(PIN_BUTTON_INC);
  gpio_set_dir(PIN_BUTTON_INC, GPIO_IN);
  gpio_pull_down(PIN_BUTTON_INC);
  gpio_set_input_enabled(PIN_BUTTON_INC, 1);

  gpio_init(PIN_LED_EYES);
  gpio_set_dir(PIN_LED_EYES, GPIO_OUT);

  gpio_init(BUILTIN_LED_R);
  gpio_set_dir(BUILTIN_LED_R, GPIO_OUT);

  gpio_init(BUILTIN_LED_G);
  gpio_set_dir(BUILTIN_LED_G, GPIO_OUT);

  gpio_init(BUILTIN_LED_B);
  gpio_set_dir(BUILTIN_LED_B, GPIO_OUT);

  gpio_init(PIN_BUZZER);
  gpio_set_dir(PIN_BUZZER, GPIO_OUT);

  gpio_init(0);
  gpio_set_dir(0, GPIO_OUT);
  gpio_put(0, 0);

  gpio_put(BUILTIN_LED_R, 1);
  gpio_put(BUILTIN_LED_G, 1);
  gpio_put(BUILTIN_LED_B, 1);

  bool var = 0;

  while (true) {
    /* gpio_put(PIN_LED_HEATER, 1); */
    /* gpio_put(PIN_LED_EYES, 1); */
    /* gpio_put(PIN_BUZZER, 1); */
    /* puts("high"); */
    /* sleep_ms(1000); */

    /* gpio_put(LED_PIN_R, 1); */
    /* gpio_put(PIN_LED_HEATER, 0); */
    /* gpio_put(PIN_LED_EYES, 0); */
    /* gpio_put(PIN_BUZZER, 0); */
    /* puts("low"); */
    /* sleep_ms(1000); */

    /* gpio_put(0, var); */

    /* var = !var; */

    printf("func inc: %d\n", gpio_get_function(PIN_BUTTON_INC));
    printf("pulled down? %d\n", gpio_is_pulled_down(PIN_BUTTON_INC));
    if (gpio_get(PIN_BUTTON_INC)) {
      puts("inc on");
    }
    else {
      puts("inc off");
    }
    printf("func dec: %d\n", gpio_get_function(PIN_BUTTON_DEC));
    printf("pulled down? %d\n", gpio_is_pulled_down(PIN_BUTTON_DEC));
    if (gpio_get(PIN_BUTTON_DEC)) {
      puts("dec on");
    }
    else {
      puts("dec off");
    }
    puts(" ");
    
    sleep_ms(200);

    const float conversion_factor = 5.0f / (1 << 12);
    uint16_t result = adc_read();
    printf("Raw value: 0x%03x, voltage: %f V\n", result, result * conversion_factor);
    //sleep_ms(500);
  }
}
